<!-- 会员列表 menber-->
<template>
  <div>
    <div class="mb20">
      <el-input clearable class="w250 mr20" clearable v-model="search_data.search" placeholder="会员名/手机号码/身份证号"></el-input>
      <el-select clearable class="mr20 w200" clearable v-model="search_data.level" placeholder="请选择类型">
        <el-option label="请选择类型" value></el-option>
        <el-option v-for="item in  GetBaseData('member','member_level')" :key="item.id" :label="item.name" :value="item.id"></el-option>
      </el-select>

      <el-button icon="el-icon-search" size="small" type="primary" @click="m_search">搜索</el-button>
      <!-- 新增 -->
      <el-button v-if="getAuto('user/add')" icon="el-icon-circle-plus" size="small" type="success" @click="m_addForm()">新增</el-button>
      <!-- 批量删除 -->
      <el-button v-if="getAuto('user/delete')" icon="el-icon-delete" size="small" type="danger" @click="m_del">批量删除</el-button>
    </div>
    <el-table ref="m_table" size="mini" border :max-height="tableHeight" v-loading="m_tableLoading" @selection-change="m_handleSelectionChange" @current-change="m_handleCurrentChange" border :stripe="true" tooltip-effect="dark" :highlight-current-row="true" :data="m_list">
      <el-table-column align="center" type="selection" width="55"></el-table-column>
      <el-table-column align="center" prop="name" label="会员账号"></el-table-column>
      <el-table-column align="center" prop="realname" label="真实姓名"></el-table-column>
      <el-table-column align="center" prop="agent" label="推荐人"></el-table-column>
       <el-table-column align="center" prop="credit1" label="余额"></el-table-column>
        <el-table-column align="center" prop="credit2" label="专用券"></el-table-column>
         <!-- <el-table-column align="center" prop="credit3" label="锁定COW"></el-table-column> -->
      <el-table-column width="100px" align="center" prop="level" label="类型">
        <template slot-scope="scope">{{scope.row.level | BaseData('member','member_level')}}</template>
      </el-table-column>

      <el-table-column width="80px" align="center" label="状态">
        <template slot-scope="scope"><span :class="scope.row.status | statusClass">{{scope.row.status | getLocBaseData('status')}}</span></template>
      </el-table-column>

      <el-table-column align="center" label="操作" width="160px">
        <template slot-scope="scope">
          <div>
            <el-button v-if="getAuto('user/set_status')&&scope.row.status==1" @click.native="handleUnfreezen(scope.row)" type="text">{{'解冻'}}</el-button>
            <el-button v-if="getAuto('user/set_status')&&scope.row.status!=1" style="color:#ff0000" @click.native="handleUnfreezen(scope.row)" type="text">{{'冻结'}}</el-button>
            <el-button v-if="getAuto('user/account')" @click="show_money(scope.row)" type="text">账户</el-button>
          </div>
          <div style="margin-top:-15px">
            <el-button v-if="getAuto('user/update')" @click.native="m_editForm(scope.row)" type="text">编辑</el-button>
            <el-button v-if="getAuto('user/delete')" style="color:#ff0000" @click.native="m_oneDel(scope.row)" type="text">删除</el-button>
            <el-button v-if="getAuto('user/delete')" style="color:green" @click.native="m_login(scope.row)" type="text">登录</el-button>

          </div>
        </template>
      </el-table-column>
    </el-table>

    <Paging class="mt20 mb30" :pageIndex="m_page.page" :pageSize="m_page.limit" :pageTotal="m_page.total" @changeSize="m_changesize" @changeIndex="m_changeindex"></Paging>

    <!-- 编辑新增谈框 -->
    <!-- 添加':'编辑 -->
    <el-dialog :close-on-click-modal="false" v-if="m_show" :title="m_isadd?'添加':'编辑'" :visible.sync="m_show" width="600px">
      <el-form :model="formData" :rules="m_rules" ref="ruleForm">
        <el-form-item label="账号" label-width="80px" prop="name">
          <el-input :disabled="!m_isadd" v-model="formData.name" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item v-if="m_isadd" label="密码" label-width="80px" prop="password">
          <el-input v-model="formData.password" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item v-if="!m_isadd" label="密码" label-width="80px">
          <el-input v-model="formData.password" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item label="类型" label-width="80px" prop="level">
          <el-select v-model="formData.level" placeholder="请选择类型">
            <el-option v-for="item in  GetBaseData('member','member_level')" :key="item.id" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="真实姓名" label-width="80px" prop="realname">
          <el-input v-model="formData.realname" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item label="手机" label-width="80px" prop="mobile">
          <el-input type="number" v-model="formData.mobile" auto-complete="off"></el-input>
        </el-form-item>

        <!-- 省市 -->
        <el-form-item label="省市" label-width="80px">
          <el-cascader :options="options" v-model="selectedOptions" @change="handleChange"></el-cascader>
        </el-form-item>

        <el-form-item label="身份证" label-width="80px">
          <el-input v-model="formData.id_card" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item label="推荐人" label-width="80px">
          <el-input :disabled="!m_isadd" v-model="formData.agent" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item label="地址" label-width="80px">
          <el-input v-model="formData.address" auto-complete="off"></el-input>
        </el-form-item>


        <!-- <el-form-item v-if="!m_isadd" label="状态" label-width="80px" prop="status">
           <el-radio-group v-model="formData.status">
            <el-radio v-for="item in locBaseData.status" :label="item.id" :key="item.id">{{item.name}}</el-radio>
          </el-radio-group>
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="m_show = false">取 消</el-button>
        <el-button type="primary" :loading="m_loading" @click.native="sureOption">确 定</el-button>
      </div>
    </el-dialog>



    <el-dialog title="设置账户" :visible.sync="money_show" width="700px" :close-on-click-modal="false">
      <div>
        <el-form :model="money_data">
          <el-form-item label="账户类型:" label-width="100px" prop="account">
            <el-radio-group v-model="money_data.account">
              <el-radio v-for="item in  GetBaseData('member','recharge')" :key="item.id" :label="item.id">{{item.name}}</el-radio>
            </el-radio-group>
          </el-form-item>

          <el-form-item label="金额:" label-width="100px" prop="money">
            <el-input type="number" v-model="money_data.money" auto-complete="off"></el-input>
          </el-form-item>

          <el-form-item label="变动类型:" label-width="100px" prop="change">
            <el-radio-group v-model="money_data.change">
              <el-radio label="1">重置</el-radio>
              <el-radio label="2">增加/减少</el-radio>
            </el-radio-group>
            <div v-show="money_data.change==1" class="m_red">(重置是设置的最终数值)</div>
            <div v-show="money_data.change==2" class="m_red">(增加/减少是基于当前数值基础进行增加/减少)</div>
          </el-form-item>
        </el-form>
      </div>

      <div slot="footer" class="dialog-footer">
        <el-button @click="money_show = false">取 消</el-button>
        <el-button @click="sumbitMoney"  type="primary" :loading="money_btn_loading">确 定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
let that
import * as utils from '@/utils/index'
import { provinceAndCityDataPlus } from 'element-china-area-data'
import * as api from '../../api/index'
export default {
  name: 'menber',
  beforeCreate() {
    that = this
  },

  data() {
    return {
      options: provinceAndCityDataPlus, //省市数据
      selectedOptions: [],
      search_data: {
        level: "",
        search: '',
        auth_status: '', //认证状态
      },

      formData: {
        name: '',//账号
        password: '',//密码
        pay_password: '',//
        realname: '', //真实姓名
        mobile: '', //手机
        id_card: '',//身份证
        agent: '',//推荐人
        province: '',//省
        city: '',//市
        address: '',//地址
        remark: '', //
        status: '0', //状态(0:正常  1:禁用)
        level: '0',//
      },

      m_rules: {
        name: [{ required: true, message: '请输入', trigger: 'blur' }],
        password: [{ required: true, message: '请输入', trigger: 'blur' }],
        realname: [{ required: true, message: '请输入', trigger: 'blur' }],
        mobile: [{ required: true, message: '请输入', trigger: 'blur' }],
      },

   

    



      //设置账户
      money_show: false,

      _money_data: {},
      money_data: {
        id: '',
        account: '1', //账户类型
        money: '',//金额
        change: '1', //变动类型 1:重置  2:增加/减少
      },
      money_btn_loading: false,




    }
  },
  watch: {
    filterText(val) {
      this.$refs.tree2.filter(val);
    }

  },

  activated() {
    if (this.$route.query.keep != 1) {
      this.m_resetData()
      this.init()
    } else {

    }
  },
  methods: {
    init() {

      this._money_data = this._dep(this.money_data)
      this.getDatalist()
    },

    //获取数据信息
    getDatalist() {
      this.m_tableLoading = true
      let data = Object.assign(this.search_data, this.m_page);

      api.members(data).then(res => {
        //console.log(res)
        this.m_list = res.data.data.map(i=>{
          i.level = i.level + ''
          return  i
        })
        this.m_page.total = res.data.total

      }).finally(() => {
        this.m_tableLoading = false
      })
    },

    m_editForm(row) {
      console.log(row)
      this.formData = JSON.parse(JSON.stringify(this._formData))
      this.m_isadd = false
      this.m_editData = JSON.parse(JSON.stringify(row));
      this.formData = utils.coverObj(this.formData, row)
      this.selectedOptions = [this.formData.province, this.formData.city]
      this.formData.id = row.id
      this.m_show = true
    },

    //省市选择
    handleChange(value) {
      console.log(value)
      this.formData.province = value[0]
      this.formData.city = value[1]
    },


    //添加
    addData() {
      this.m_loading = true

      api.members_add(this.formData).then(res => {
        this.m_page.page = 1
        //this.m_loading = false
        // 添加成功
        this.m_success('添加成功')
        this.m_show = false
        this.getDatalist()
      }).catch(res => {

      }).finally(() => {
        this.m_loading = false
      })
    },

    //编辑
    editData() {
      this.m_loading = true
      api.members_edit(this.formData).then(res => {
        // 修改成功
        this.m_success('修改成功')
        this.m_show = false
        this.getDatalist()
      }).catch(res => {

      }).finally(() => {
        this.m_loading = false
      })
    },


    //删除
    delData(id) {
      let m_delId = id ? [id] : this.m_delId
      this.m_loading = true
      console.log(222)
      api.members_del(m_delId).then(res => {
        // 删除成功
        this.m_loading = false
        this.m_success('删除成功')
        this.getDatalist()
      }).catch(res => {
        this.m_loading = false
      })
    },

    //解冻
    handleUnfreezen(row) {
      console.log(row)
      let _data = {
        msg: `是否${row.status == 1 ? '解冻' : '冻结'}会员：${row.name}`
      }
      this.m_confirm(_data).then(res => {
        if (res) {
          let status = row.status == 1 ? '0' : 1
          let d = {
            id: row.id,
            status,
          }
          this.unfreeze(d)
        }
      })
    },

    //会员解冻
    unfreeze(data) {
      this.m_api.unfreeze(data).then(res => {
        this.m_success('操作成功')
        this.getDatalist()
      })
    },



 



    //展示账户设置
    show_money(row) {
      this.money_data = this._dep(this._money_data)
      console.log(this.money_data)
      this.money_data.id = row.id
      this.money_show = true

    },

    //提交账户设置
    sumbitMoney() {
      this.money_btn_loading = true
      this.m_api.set_credit(this.money_data).then(res => {
        this.money_btn_loading = false
        this.m_success('设置成功')
        this.getDatalist()
        this.money_show = false

      }).catch(err => {
        this.money_btn_loading = false

      })
    },

  





  },



}

</script>
<style lang='scss' scoped>
.ad_img {
  width: 100px;
  height: 100px;
}
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
  border: 1px dashed #d9d9d9;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
  border: 1px dashed #d9d9d9;
}
</style>